#!/bin/ksh
# ******************************************************************************************************************************
# * Licensed Materials - Property of IBM                                                                                       *
# * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
# *                                                                                                                            *
# *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
# ******************************************************************************************************************************

rcrdone(){
db2 connect reset
db2 terminate
echo $MESSAGE.$ACTION:$EXITCODE
echo $CRREWECH002$
exit $EXITCODE
}

validate() {

if [ -z $CURINST ] 
then
	EXITCODE=$CRREW4501E
	MESSAGE=$CRREWMSGE001
	rcrdone
fi  

if [ -z $DBNAME ] 
then
	EXITCODE=$CRREW4502E
	MESSAGE=$CRREWMSGE002
	rcrdone
fi

if [ -z $DBUSER ] 
then
	EXITCODE=$CRREW4503E
	MESSAGE=$CRREWMSGE003
	rcrdone
fi

if [ -z $DBPASSWD ] 
then
	EXITCODE=$CRREW4504E
	MESSAGE=$CRREWMSGE004
	rcrdone
fi

if [ -z $NF_SCHEMA ] 
then
	EXITCODE=$CRREW4505E
	MESSAGE=$CRREWMSGE005
	rcrdone
fi

if [ -z $STAR_SCHEMA ] 
then
	EXITCODE=$CRREW4506E
	MESSAGE=$CRREWMSGE006
	rcrdone
fi

if [ -z $REP_USER ] 
then
	EXITCODE=$CRREW4507E
	MESSAGE=$CRREWMSGE007
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRREW4595E
	MESSAGE=$CRREWMSGE095
	rcrdone
fi

if [ -z $DATA_HOME ] 
then
	EXITCODE=$CRREW4508E
	MESSAGE=$CRREWMSGE008
	rcrdone
fi

if [ -z $START_YEAR  ] 
then
	EXITCODE=$CRREW4509E
	MESSAGE=$CRREWMSGE009
	rcrdone
fi


if [ -z $END_YEAR ] 
then
	EXITCODE=$CRREW4510E
	MESSAGE=$CRREWMSGE010
	rcrdone
fi




if [ -z $LANG ]
then
	EXITCODE=$CRREW4585E
	MESSAGE=$CRREWMSGE085
	rcrdone
fi

db2ilist>db2ilist.txt
grep -e $CURINST db2ilist.txt>/dev/null
if [ $? -eq 1 ]
then
	rm -f db2ilist.txt
	EXITCODE=$CRREW4501E
	MESSAGE=$CRREWMSGE001
	rcrdone
fi  

rm -f db2ilist.txt

db2 attach to  $CURINST user $DBUSER using  "$DBPASSWD"
if [ $? -ne 0 ] 
then
	EXITCODE=$CRREW4584E
	MESSAGE=$CRREWMSGE084
	rcrdone
fi  






rcrdone
}

createriba() {
$DB2_CMD ./work_spc/ddl/createRIBA.ddl> ./logs/createRIBA.log
grep -e " SQLSTATE" $CD/logs/createRIBA.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE106
	EXITCODE=$CRREW4606E
	ACTION=$CRREWECH034
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/riba_grants.sql> ./logs/riba_grants.log
grep -e " SQLSTATE" $CD/logs/riba_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE023
	EXITCODE=$CRREW4523E
	ACTION=$CRREWECH013
	rcrdone
fi
}


createdb() {
$DB2_CMD $CD/work_spc/createDB/createdb.sql >$CD/logs/createdb.log
grep -e "SQLSTATE" $CD/logs/createdb.log >/dev/null

if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE013  
	EXITCODE=$CRREW4513E
	ACTION=$CRREWECH003
	rcrdone
fi
chmod +x ./work_spc/createDB/db2_set.sh
./work_spc/createDB/db2_set.sh
db2set>./logs/db2_set.log
chmod +x ./work_spc/createDB/db_cfg.sh
./work_spc/createDB/db_cfg.sh $DBNAME>./logs/db_cfg.log
chmod +x ./work_spc/createDB/dbm_cfg.sh
./work_spc/createDB/dbm_cfg.sh>./logs/dbm_cfg.log

# DB2 9.1 doesn't support AUTOMATIC keyword, keeping up the same value with MAXAGENTS
if test "`db2licm -v`" = "9.1"; then
	db2 UPDATE DBM CFG USING MAX_CONNECTIONS -1
	db2 UPDATE DBM CFG USING MAX_COORDAGENTS -1
	db2 UPDATE DBM CFG USING FENCED_POOL -1
else
	db2 UPDATE DBM CFG USING MAX_CONNECTIONS AUTOMATIC
	db2 UPDATE DBM CFG USING MAX_COORDAGENTS AUTOMATIC
	db2 UPDATE DBM CFG USING FENCED_POOL AUTOMATIC
fi

$CONNSTR

$DB2_CMD ./work_spc/createDB/bufferpool.sql> ./logs/bufferpool.log
grep -e "SQLSTATE" $CD/logs/bufferpool.log>/dev/null
#if [ $? -eq 0 ]
#then
#	MESSAGE=$CRREWMSGE014 
#	EXITCODE=$CRREW4514E
#	echo $CRREWECH004
#	rcrdone
#fi

db2 force applications all
db2stop force
db2start

$CONNSTR

$DB2_CMD ./work_spc/createDB/tbspace.sql> ./logs/tbspace.log
grep -e " SQLSTATE" $CD/logs/tbspace.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE015
	EXITCODE=$CRREW4515E
	ACTION=$CRREWECH005
	rcrdone
fi

}

chmod -R +x lang

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "en" ]
then 
     LOCALE="en"
	. lang/en/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "it" ]
then 
	LOCALE="it"
	. lang/it/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "pl" ]
then 
	LOCALE="pl"
	. lang/pl/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ko" ]
then 
	LOCALE="kr"
	. lang/kr/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ja" ]
then 
	LOCALE="ja"
	. lang/ja/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_CN" ]
then 
	LOCALE="zh_CN"
	. lang/zh_CN/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_TW" ]
then 
	LOCALE="zh_TW"
	. lang/zh_TW/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "de" ]
then 
	LOCALE="de"
	. lang/de/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "es" ]
then 
	LOCALE="es"
	. lang/es/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "fr" ]
then 
	LOCALE="fr"
	. lang/fr/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "pt_BR" ]
then 
	LOCALE="pt_BR"
	. lang/pt_BR/messages.sh
fi

if [ -z $LOCALE ]
then
	 LOCALE="en"
	. lang/en/messages.sh
fi	


SILENT=0
FLAG_SCHEMA=0
SCHEMA_RIBA=0
MESSAGE="No errors"
EXITCODE=0
ACTION=""

DB2_CMD="db2 -tsf"

if [ $# -eq 1 ]
	then 
	if [ $1 = "-silent" ]
	then
			SILENT=1
	else 
			SILENT=0
	fi
	if [ $1 = "-debug" ]
	then
		DB2_CMD="db2 -tvsf"
		else 
			DB2_CMD="db2 -tsf"
	fi
fi

if [ $# -eq 1 ]
	then
	if [ $1 = "-validate" ]
		then
		   validate
	fi
fi	
	
if [ $# -eq 2 ]
then
	if [ $2 = "-debug" ]
	 then
			DB2_CMD="db2 -tvsf"
	else 
			DB2_CMD="db2 -tsf"
	fi
fi

if [ $# -eq 3 ]
then
	if [ $3 = "-debug" ]
	 then
			DB2_CMD="db2 -tvsf"
	else 
			DB2_CMD="db2 -tsf"
	fi
fi

if [ $# -eq 1 ]
then
	if [ $1 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	else 
		FLAG_SCHEMA=0
	fi
fi

if [ $# -eq 2 ]
then
	if [ $1 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	fi
	if [ $2 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	 else
	 		FLAG_SCHEMA=0
	fi
fi

for I in $@
do
	if [ $I = "-riba" ]
	then
		SCHEMA_RIBA=1
	fi   
done

if [ $SILENT -eq 0 ]
then 
	. ./parameters.sh
fi	


if [ -z $DBNAME ]
then
	MESSAGE=$CRREWMSGE002
	EXITCODE=$CRREW4502E
	rcrdone
fi

if [ -z $DBUSER ]
then
	MESSAGE=$CRREWMSGE003
	EXITCODE=$CRREW4503E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT004
	read DBPASSWD
fi

if [ -z $DBPASSWD ]
then
	MESSAGE=$CRREWMSGE004
	EXITCODE=$CRREW4504E
	rcrdone
fi

if [ -z $NF_SCHEMA ]
then
	MESSAGE=$CRREWMSGE005
	EXITCODE=$CRREW4505E
	rcrdone
fi

if [ -z $STAR_SCHEMA ]
then
	MESSAGE=$CRREWMSGE006
	EXITCODE=$CRREW4506E
	rcrdone
fi

if [ -z $RIBA_SCHEMA ]
then
	MESSAGE=$CRREWMSGE105
	EXITCODE=$CRREW4605E
	rcrdone
fi

if [ -z $RIASSET_SCHEMA ]
then
	MESSAGE=$CRREWMSGE110
	EXITCODE=$CRREW4610E
	rcrdone
fi

if [ -z $RISCHK_SCHEMA ]
then
	MESSAGE=$CRREWMSGE115
	EXITCODE=$CRREW4615E
	rcrdone
fi

if [ -z $REP_USER ]
then
	MESSAGE=$CRREWMSGE007
	EXITCODE=$CRREW4507E
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRREW4595E
	MESSAGE=$CRREWMSGE095
	rcrdone
fi

if [ -z $DATA_HOME ]
then
	MESSAGE=$CRREWMSGE008
	EXITCODE=$CRREW4508E
	rcrdone
fi


DATA_HOME=$DATA_HOME/$DBNAME

if [ -z $START_YEAR ]
then
	MESSAGE=$CRREWMSGE009
	EXITCODE=$CRREW4509E
	rcrdone
fi

if [ -z $END_YEAR ]
then
	MESSAGE=$CRREWMSGE010
	EXITCODE=$CRREW4510E
	rcrdone
fi


CONNSTR="db2 CONNECT TO $DBNAME USER '$DBUSER' USING '$DBPASSWD'"

if [ $SILENT -eq 1 ]
then 
	$CONNSTR
	db2 "SELECT COUNT(*) FROM CONFIG.ETL_INFO"
	if [ $? -eq 0 ]
	then
		rcrdone
	fi
fi	


CD=`pwd`

if [ ! -d $CD/work_spc ]
then
	mkdir $CD/work_spc
else
	rm -fr $CD/work_spc
	mkdir $CD/work_spc
fi	
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi
    

if [ ! -d $CD/logs ]
then
	mkdir $CD/logs
else
	rm -fr $CD/logs
	mkdir $CD/logs	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi
echo $DATA_HOME/|sed 's/\//\\\//g'>tmp1.txt


cp -r ./createDB $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi

cp -r ./ddl $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi
cp -r ./scripts $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi

cat ./createDB/createdb.sql|sed -e "s/\$DBNAME/`echo $DBNAME`/g" > $CD/work_spc/createDB/createdb.sql
cat ./createDB/tbspace.sql|sed -e "s/\$BASEDIR/`cat tmp1.txt`/g" > $CD/work_spc/createDB/tbspace.sql
rm -f tmp1.txt
cat ./ddl/createNF.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/ddl/createNF.ddl
cat ./scripts/initNF.sql|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/scripts/initNF.sql
cat ./ddl/createSTAR.ddl|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/ddl/createSTAR.ddl
cat ./ddl/createSTARViews.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" |sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g" |sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g"> $CD/work_spc/ddl/createSTARViews.ddl
cat ./scripts/initSTAR.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/scripts/initSTAR.sql
cat ./ddl/createRIBA.ddl|sed -e "s/\$RIBA_SCHEMA/`echo $RIBA_SCHEMA`/g" > $CD/work_spc/ddl/createRIBA.ddl
cat ./ddl/createRIASSET.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" |sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g"> $CD/work_spc/ddl/createRIASSET.ddl
cat ./ddl/createRISCHK.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" |sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g"> $CD/work_spc/ddl/createRISCHK.ddl
cat ./scripts/initRIASSET.sql|sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g" > $CD/work_spc/scripts/initRIASSET.sql
cat ./scripts/initRISCHK.sql|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g" > $CD/work_spc/scripts/initRISCHK.sql
cat ./scripts/star_grants.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$RIBA_SCHEMA/`echo $RIBA_SCHEMA`/g"|sed -e "s/\$REP_USER/`echo $REP_USER`/g"> $CD/work_spc/scripts/star_grants.sql
cat ./scripts/riba_grants.sql|sed -e "s/\$RIBA_SCHEMA/`echo $RIBA_SCHEMA`/g"|sed -e "s/\$REP_USER/`echo $REP_USER`/g"> $CD/work_spc/scripts/riba_grants.sql

if [ $FLAG_SCHEMA -eq 0 ]
then 
	createdb
fi	

if [ $SCHEMA_RIBA -eq 1 ]
then 
	$CONNSTR
	createriba
	rcrdone
fi

$CONNSTR

$DB2_CMD ./work_spc/ddl/createSTGCFG.ddl> ./logs/createSTGCFG.log
grep -e " SQLSTATE" $CD/logs/createSTGCFG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE016
	EXITCODE=$CRREW4516E
	ACTION=$CRREWECH006
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createNF.ddl> ./logs/createNF.log
grep -e " SQLSTATE" $CD/logs/createNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE017
	EXITCODE=$CRREW4517E
	ACTION=$CRREWECH007
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createSTAR.ddl> ./logs/createSTAR.log
grep -e " SQLSTATE" $CD/logs/createSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE018
	EXITCODE=$CRREW4518E
	ACTION=$CRREWECH008
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createRIBA.ddl> ./logs/createRIBA.log
grep -e " SQLSTATE" $CD/logs/createRIBA.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE106
	EXITCODE=$CRREW4606E
	ACTION=$CRREWECH034
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createRIASSET.ddl> ./logs/createRIASSET.log
grep -e " SQLSTATE" $CD/logs/createRIASSET.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE111
	EXITCODE=$CRREW4611E
	ACTION=$CRREWECH037
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createRISCHK.ddl> ./logs/createRISCHK.log
grep -e " SQLSTATE" $CD/logs/createRISCHK.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE113
	EXITCODE=$CRREW4613E
	ACTION=$CRREWECH039
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createSTARViews.ddl> ./logs/createSTARViews.log
grep -e " SQLSTATE" $CD/logs/createSTARViews.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE019
	EXITCODE=$CRREW4519E
	ACTION=$CRREWECH009
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initCONFIG.sql> ./logs/initCONFIG.log
grep -e " SQLSTATE" $CD/logs/initCONFIG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE020
	EXITCODE=$CRREW4520E
	ACTION=$CRREWECH010
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initNF.sql> ./logs/initNF.log
grep -e " SQLSTATE" $CD/logs/initNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE021
	EXITCODE=$CRREW4521E
	ACTION=$CRREWECH011
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initRIASSET.sql> ./logs/initRIASSET.log
grep -e " SQLSTATE" $CD/logs/initRIASSET.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE112
	EXITCODE=$CRREW4612E
	ACTION=$CRREWECH038
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initRISCHK.sql> ./logs/initRISCHK.log
grep -e " SQLSTATE" $CD/logs/initRISCHK.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE114
	EXITCODE=$CRREW4614E
	ACTION=$CRREWECH040
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initSTAR.sql> ./logs/initSTAR.log
grep -e " SQLSTATE" $CD/logs/initSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE022
	EXITCODE=$CRREW4522E
	ACTION=$CRREWECH012
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/star_grants.sql> ./logs/star_grants.log
grep -e " SQLSTATE" $CD/logs/star_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE023
	EXITCODE=$CRREW4523E
	ACTION=$CRREWECH013
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/riba_grants.sql> ./logs/riba_grants.log
grep -e " SQLSTATE" $CD/logs/riba_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE023
	EXITCODE=$CRREW4523E
	ACTION=$CRREWECH013
	rcrdone
fi

java -cp .:$CLASSPATH -Ddbms="DB2" -Dalias="$DBNAME" -Dschema="$STAR_SCHEMA" -Dstart="$START_YEAR" -Dend="$END_YEAR" com.ibm.rational.rcpr.dw.procedures.PopulateD_DATE>./logs/populate-D_DATE.log

$DB2_CMD ./work_spc/scripts/initD_Date.sql> ./logs/initD_Date.log
grep -e " SQLSTATE" $CD/logs/initD_Date.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE025 
	EXITCODE=$CRREW4525E 
	ACTION=$CRREWECH014
	rcrdone
fi

rcrdone


