@echo off

rem Default DB2 instance to use.  If the database needs to be
rem deployed on a different instance change the value of CURINST

SET CURINST=DB2

rem Default Rational Insight database ALIAS instance to use. 
rem if a different value is required change the value of DBNAME
rem Not accepting the default implies changes in the connection information
rem defined on the Cognos BI server and Data Manager ETL

SET DBNAME=RIDW

rem Default account to use to execute the database installation.
rem If a different value is required change the value of DBUSER
rem Make sure to make the appropriate changes in the Data Manager credentials
rem for the "Rational Data Warehouse" connection 

SET DBUSER=db2admin


rem Default schema name to use for the Operational Data Store.
rem If a different value is required change the value of NF_SCHEMA.
rem Not accepting the default implies that the Data Manager 
rem ETL variable ODS will have to be changed as well


SET NF_SCHEMA=RIODS

rem Default schema name to use for the Asset Management Operational Data Store.
rem If a different value is required change the value of RIASSET_SCHEMA.
rem Not accepting the default implies that the Data Manager 
rem ETL variables will have to be changed as well


SET RIASSET_SCHEMA=RIASSET

rem Default schema name to use for the MCIF Self-Check Operational Data Store.
rem If a different value is required change the value of RISCHK_SCHEMA.
rem Not accepting the default implies that the Data Manager 
rem ETL variables will have to be changed as well

SET RISCHK_SCHEMA=RISCHK

rem Default schema name to use for the Data Mart.
rem If a different value is required change the value of STAR_SCHEMA.
rem Not accepting the default implies that the Frame Work Manager 
rem meta-data model will need to be altered as well as as all published reports.
rem Additionally the Data Manager ETL variable DW will have to be changed as well.


SET STAR_SCHEMA=RIDW

rem Default schema name to use for the Business Analytics area of the database.
rem If a different value is required change the value of RIBA.
rem Not accepting the default implies that the Frame Work Manager 
rem meta-data model will need to be altered as well as as all published reports.
rem Additionally the Data Manager ETL variable will have to be changed as well.

SET RIBA_SCHEMA=RIBA

rem Default account to use for the report executions.
rem If a different value is required change the value of REP_USER.
rem Not accepting the defaults implies that RIDW connection
rem in the Cognos BI server will have to be changed

SET REP_USER=RPTUSER

rem Default path for the table space files.
rem Change the value of DATA_HOME to any suitable value for your system

SET DATA_HOME=%USERPROFILE%\databases

rem Default start year from which to populate the 
rem date dimension in the data mart.  If the default is not suitable 
rem change the value of START_YEAR to any sensible value required.

SET START_YEAR=2008

rem Default end year up to which to populate the 
rem date dimension in the data mart.  If the default is not suitable 
rem change the value of END_YEAR to any sensible value required.
rem END_YEAR must be greater than the value specified for START_YEAR

SET END_YEAR=2012